unit uMemMapExampleConsts;

{******************************************************************************
Initial Author   :    Scott Price
Initially Created:    06-Apr-2003
Language         :    Object Pascal
Compiler Version :    Delphi 3.02, 4.03, 5.01, 6.02 (UK)
Copyright        :     Information Technology Sector Limited, 1996-2002

Source Code Constraints:
========================
   Distribution, disclosure or modifications of this source code, outside of
   any licenced agreements with Information Technology Sector Limited, or
   removal of this notice constitutes a breach of any or all license agreements.

Operating Systems Tested On:
============================
   Microsoft Windows(R) 98, First Edition
   Microsoft Windows(R) 2000, Service Pack 2

Design Notes:
=============

VERSION  AUTHOR                DATE/TIME
===============================================================================
$history$
$nokeywords$
===============================================================================
NOTES:
===============================================================================
TODO:
******************************************************************************}


interface



uses
  { Own Units }
  uMemMap;


const
  scMemMapID = 'UK-BUG.2003.April.08.CrossProcessData';
  icMemMapDataSize{: Integer} = 1024;  { Seems Delphi 6 doesn't like me defining a typed constant  :S }


type
  { TMappedMemData
    This is an example of a record type-casted memory access }

  TMappedMemData = record
    dwVersion: Cardinal;
    dwSize: Cardinal;
    Data: array[0..icMemMapDataSize-1] of Integer;
  end;
  PMappedMemData = ^TMappedMemData;


  { TMemMapExample }

  TMemMapExample = class(TMemoryMapping)
  private
    function GetTypedMemory: PMappedMemData;
    { Private Declarations }
  protected
    { Protected Declarations }
  public
    { Public Declarations }
    constructor Create; override;
    property Memory: PMappedMemData read GetTypedMemory;
  published
    { Published Declarations }
  end;



implementation



uses
  { Borland Standard Units }
  Windows;


  { TMemMapExample }

constructor TMemMapExample.Create;
begin
  inherited Create;

  Size := SizeOf(TMappedMemData);
  { These access rights are essential! }
  Access := FILE_MAP_ALL_ACCESS;
  MemMapIdent := scMemMapID;
end;

function TMemMapExample.GetTypedMemory: PMappedMemData;
begin
  { Type case the plain pointer returned into a Tpyed Pointer }
  Result := PMappedMemData(GetMemory);
end;

end.
